
;*****************************************************************************
;*                         AQUARIUMLEUCHTE LED  SONNENAUF- UND UNTERGANG     *
;*                              23.10.12                                     *
;*---------------------------------------------------------------------------*
;*                           BEGINN: 23.10.12                                *
;*                           ENDE  : 01.11.12                                *
;*                         GETESTET: 01.11.12                                *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "AQUARIUMLEUCHTE"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

                        ORG 22H 

MERK                    RES     1               
ZAE                     RES     1
ZAE1                    RES     1
AD_H                    RES     1
AD_L                    RES     1
HELL_H                  RES     1
HELL_L                  RES     1
DUNKEL_H                RES     1
DUNKEL_L                RES     1
HELL0_H                 RES     1
HELL0_L                 RES     1
DUNKEL0_H               RES     1
DUNKEL0_L               RES     1
HOCHRUNTER              RES     1
ZAEHLER_L               RES     1
ZAEHLER_H               RES     1

W_STACK                 RES     1               ;FUER PUSH UND POP
S_STACK                 RES     1               ;FUER PUSH UND POP


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
PUSH                    MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
POP                     MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; SOFORT INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              04.05.12                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                        MOVLW   B'00111000'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP0 + GP1 DIGITAL I/O     AN3 -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                        MOVLW   B'11111100'                 ;GP0 + GP1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1))
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL 
                        BANK0

;INIT TIMER 1 
                        MOVLW   B'00110000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [11]1:8 VORERST 0
                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'00001100' ;ADMF=0 LINKSSBNDIG, VDD ALS REF, CHANNEL AN3, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;---------------INITIALISIERUNG--ZU--ENDE-----------------------

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZEITSCHLEIFE 1SEC   ZUM AUFLADEN VON 47NF KONDENSATOR AM SCHLEIFER VOM EINSTELLREGLER FR AD-MESSUNG

                BCF     GPIO, GP1           ;MOSFET AUF AUS, LICHTERKETTE LEUCHTET NICHT
 
                CALL    SEC1                ;ZEITSCHLEIFE 1SEC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SOLL DER SONNENAUFGANG GESTARTET WERDEN ??? 

ABFRAGE_HO      BTFSS   GPIO, GP2
                GOTO    ABFRAGE_HO
                CALL    SEC1                ;ZEITSCHLEIFE 1SEC  ENTPRELLUNG
                BTFSS   GPIO, GP2
                GOTO    ABFRAGE_HO

                BSF     HOCHRUNTER, BIT0    ;MERKER BIT GESETZT FUER HOCHDIMMEN
                BCF     HOCHRUNTER, BIT1    ;MERKER BIT FUER ENDEERKENNUNG LOESCHEN
                CALL    ADWANDLUNG
                GOTO    ANFANG


ABFRAGE_RU      BTFSC   GPIO, GP2
                GOTO    ABFRAGE_RU
                CALL    SEC1                ;ZEITSCHLEIFE 1SEC  ENTPRELLUNG
                BTFSC   GPIO, GP2
                GOTO    ABFRAGE_RU

                BCF     HOCHRUNTER, BIT0    ;MERKER BIT GESETZT FUER RUNTERDIMMEN
                BCF     HOCHRUNTER, BIT1    ;MERKER BIT FUER ENDEERKENNUNG LOESCHEN
                CALL    ADWANDLUNG
;               GOTO    ANFANG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ANFANG      BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    ANFANG

                        MOVF    HELL0_L, W
                        MOVWF   HELL_L                 
                        MOVF    HELL0_H, W
                        MOVWF   HELL_H

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

                        BSF     GPIO, GP1       ;LED EIN

WEITER1                 NOP         ;5SEC
                        NOP
                        NOP
                        NOP
                        NOP
 
                        MOVLW   D'1'            
                        SUBWF   HELL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1
                        MOVLW   D'1'
                        SUBWF   HELL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER1         

;------------------------------- 
SE1         BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
            BTFSC   INTCON, GIE
            GOTO    SE1
 
                        MOVF    DUNKEL0_L, W
                        MOVWF   DUNKEL_L                 
                        MOVF    DUNKEL0_H, W
                        MOVWF   DUNKEL_H   

            BSF     INTCON, GIE        ;INTERRUPT WIEDER ZULASSEN

                        BCF     GPIO, GP1       ;LED AUS

WEITER2                 NOP         ;5SEC
                        NOP
                        NOP
                        NOP
                        NOP
 
                        MOVLW   D'1'            
                        SUBWF   DUNKEL_L, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2
                        MOVLW   D'1'
                        SUBWF   DUNKEL_H, F
                        BTFSC   STATUS, C
                        GOTO    WEITER2         

                        BTFSS   HOCHRUNTER, BIT1 ;ENDEKENNUNG ABFRAGEN
                        GOTO    ANFANG

SEA                     BCF     INTCON, GIE         ;INTERRUPT SPERREN, 
                        BTFSC   INTCON, GIE
                        GOTO    SEA
                        
                        BTFSC   HOCHRUNTER, BIT0
                        GOTO    EIN1

                        BCF     GPIO, GP1       ;LED IST AUS
                        GOTO    WW1

EIN1                    BSF     GPIO, GP1       ;LED IST EIN
            
WW1                     BTFSS   HOCHRUNTER, BIT0
                        GOTO    ABFRAGE_HO          ;ZU HOCHDIMMEN
                        GOTO    ABFRAGE_RU          ;ZU RUNTERDIMMEN
 

;*****************************************************************************
;*                              CA. 40S ZEITSCHLEIFE                        *
;*                              31.10.03                                     *
;*****************************************************************************

MUE40       MOVLW   D'4'
            MOVWF   ZAE1
MSA2        NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ  ZAE1, F
            GOTO    MSA2
            RETURN

;*****************************************************************************
;*                              CA. 1SEC ZEITSCHLEIFE                        *
;*                              31.10.03                                     *
;*****************************************************************************

SEC1            MOVLW   D'100'
                MOVWF   MERK

ZEITW           MOVLW   D'200'
                MOVWF   ZAE
ZEIT1           CALL    MUE40               ;ZEITSCHLEIFE 40SEC
                NOP                         ;10X NOP = +10SEC
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP                         ;== 50SEC
                DECFSZ  ZAE, F
                GOTO    ZEIT1

                DECFSZ  MERK, F
                GOTO    ZEITW
                RETURN

;FERTIG MIT 200*100*50SEC=1SEC

;*****************************************************************************
;*                              AD-WANDLUNG                                  *
;*                              31.10.03                                     *
;*****************************************************************************
ADWANDLUNG      BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    MUE40               ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    MUE40               ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                        MOVF    ADRESH, W
                        MOVWF   AD_H
                        BANK1
                        MOVF    ADRESL, W
                        BANK0
                        MOVWF   AD_L


                MOVLW   D'2'           ;INTERRUPT 2X DURCHLAUFEN DANN HELL UND DUNKEL NDERN +1 -1
                MOVWF   MERK

                MOVLW   0X01            ;ENDEERKENNUNGS-ZAEHLER LADEN
                MOVWF   ZAEHLER_L
                CLRF    ZAEHLER_H

;ENTSCHEIDEN OB HOCH- ODER RUNTER-DIMMEN
                BTFSS   HOCHRUNTER, BIT0
                GOTO    RUNT

;RAM-ZELLEN LADEN FUER DAS HOCH-DIMMEN
                MOVLW   0X01
                MOVWF   HELL0_L
                CLRF    HELL0_H
   
                MOVLW   0XFF
                MOVWF   DUNKEL0_L
                MOVLW   0X03
                MOVWF   DUNKEL0_H
                GOTO    INTZULAS

;RAM-ZELLEN LADEN FUER DAS RUNTER-DIMMEN
 RUNT           MOVLW   0X01
                MOVWF   DUNKEL0_L
                CLRF    DUNKEL0_H
   
                MOVLW   0XFF
                MOVWF   HELL0_L
                MOVLW   0X03
                MOVWF   HELL0_H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;INTERRUPT ZULASSEN
INTZULAS        BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE
                BSF     INTCON, PEIE
                BANK1
                BSF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 ZULASSEN/ENABLE
                BANK0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN
                BSF     T1CON, TMR1ON   ;START DES TIMER1

                BSF     GPIO, GP0       ;KONTROLL LED EIN

                RETURN

;*****************************************************************************
;*                              INTERRUPT                                    *
;*                              04.06.12                                     *
;*****************************************************************************
INTERRUPT       PUSH
                BCF     T1CON, TMR1ON   ;STOP DES TIMER1
                BCF     PIR1, TMR1IF    ;OVERFLOW 0 MACHEN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                MOVF    AD_L, W        
                MOVWF   TMR1L       
                MOVF    AD_H, W
                MOVWF   TMR1H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                DECFSZ  MERK, F
                GOTO    AA1

                BTFSS   HOCHRUNTER, BIT0
                GOTO    INTR

                MOVLW   D'1'            
                SUBWF   DUNKEL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1
                DECF    DUNKEL0_H, F

INT1            INCFSZ  HELL0_L, F
                GOTO    INT2
                INCF    HELL0_H, F

INT2            INCFSZ  ZAEHLER_L, F
                GOTO    INT3
                INCF    ZAEHLER_H, F
                GOTO    INT3



INTR            MOVLW   D'1'            
                SUBWF   HELL0_L, F
                BTFSC   STATUS, C
                GOTO    INT1R
                DECF    HELL0_H, F

INT1R           INCFSZ  DUNKEL0_L, F
                GOTO    INT2R
                INCF    DUNKEL0_H, F

INT2R           INCFSZ  ZAEHLER_L, F
                GOTO    INT3
                INCF    ZAEHLER_H, F



INT3            MOVLW   D'2'            ;INTERRUPT 2X DURCHLAUFEN DANN HELL UND DUNKEL NDERN +1 -1
                MOVWF   MERK

                MOVLW   0XFE            ;ENDE BEI 0X03FE -- ZAEHLER                   
                SUBWF   ZAEHLER_L, W
                BTFSS   STATUS, Z
                GOTO    AA1

                MOVLW   0X03                   
                SUBWF   ZAEHLER_H, W
                BTFSS   STATUS, Z
                GOTO    AA1

;                BCF     INTCON, GIE     ;ALLGEMEINES INTERRUPT SPERREN

                BCF     GPIO, GP0       ;CONTROLL LED AUS
   
                BSF     HOCHRUNTER, BIT1 ;ENDEKENNUNG

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

AA1             BSF     T1CON, TMR1ON   ;START DES TIMER1
                POP
                RETFIE


            END